--I lay no claim to this script, (apart from a few adjustments and the removal of the tractor beam). I found it in DSTech.rte, used for their Apis unit.

dofile("Base.rte/Constants.lua")
require("Actors/AI/NativeHumanAI")
function Create(self)
	self.AI = NativeHumanAI:Create(self)
	self.massModifier = 1;
end


function Update(self)

	if self.Mass ~= self.savedMass then

		self.massModifier = 1 - ((self.Mass - 131) / 170); -- 131 is base mass
		if self.massModifier <= 0 then
			self.massModifier = 0.05;
		end
		
	end
	
	self.savedMass = self.Mass;

	self.maxSpeedLeft = -10 * self.massModifier;
	self.maxSpeedRight = 10 * self.massModifier;

	acceleration = 1 * self.massModifier;
	deceleration =  .1 * (self.massModifier / 3);
	self.RotAngle = 0;
	self.rotFactor = 0.2;
	self:ClearForces();
	self:ClearImpulseForces();
	self.hoverheight = 37 * self.massModifier;
	if self.hoverheight < 20 then
		self.hoverheight = 20;
	end
	
	
	--How softly the hoverboard should move to its desired position (the higher this number is, the easier it is to fall of from crashing into the ground below).
	self.landsoftness = 10;

	--Multiplied by the Y velocity to stop from hitting the ground.
	self.landdamping = 0.7;
		--Credits to CaveCricket48
   if self:IsPlayerControlled() == false and self.AIMode == Actor.AIMODE_SENTRY then
	   self:GetController():SetState(Controller.BODY_CROUCH,false);
	   self:GetController():SetState(Controller.MOVE_RIGHT,false);
	   self:GetController():SetState(Controller.MOVE_LEFT,false);
   else
		if self:GetController():IsState(Controller.MOVE_LEFT) then	
			if self.Vel.X > self.maxSpeedLeft then
				self.Vel.X = self.Vel.X - acceleration;
				self.fx2 = CreateMOSParticle("Fire Puff Small")
				self.fx2:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1)
				self.fx2.Pos = self.Pos
				MovableMan:AddParticle(self.fx2)
			end
			
		elseif self:GetController():IsState(Controller.MOVE_RIGHT) then
			if self.Vel.X < self.maxSpeedRight then
				self.Vel.X = self.Vel.X + acceleration;
				self.fx2 = CreateMOSParticle("Fire Puff Small")
				self.fx2:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1)
				self.fx2.Pos = self.Pos
				MovableMan:AddParticle(self.fx2)
			end
		else
			if self.Vel.X ~= 0 then
				self.Vel.X = self.Vel.X / 2;
			end
		end
	end
	

	
	--Vertical Movement
	if self:GetController():IsState(Controller.BODY_JUMP ) then
		if self.Vel.Y > -4 then
			self.Vel.Y = self.Vel.Y - acceleration;
			self.fx2 = CreateMOSParticle("Fire Puff Small")
			self.fx2:SetWhichMOToNotHit(MovableMan:GetMOFromID(self.RootID),-1)
			self.fx2.Pos = self.Pos
			MovableMan:AddParticle(self.fx2)
		end	
	elseif self:GetController():IsState(Controller.MOVE_DOWN) then
		hoverheight = 0;
	else
		hoverpoint = SceneMan:MovePointToGround(self.Pos + Vector(self.Vel.X,0),0,3).Y - self.hoverheight;
		if self.Pos.Y > hoverpoint then
			--Hover at the right position.
			--This gives it the right position.
			self.Pos.Y = ((self.Pos.Y * self.landsoftness) + hoverpoint) / (self.landsoftness + 1);
			--This minimizes the effects of gravity.
			if self.Vel.Y > 0 then
				self.Vel.Y = self.Vel.Y * self.landdamping;
			end
		end
		hoverheight = 37;
	end
	if self.Health <= 0 then
		self:GibThis();
	end
			
end
function UpdateAI(self)
	self.AI:Update(self)
end